﻿import Vue from 'vue';
import Ajax from './math/ajax';
import AjaxPro from './math/ajax_pro';
import Cache from './math/cache';
import DataModel from './math/data_model';
import DateTool from './math/date_tool/index';
import Event from './math/event';
import Global from './math/global';
import {tools as OptionTool, Options} from './math/option_tool';
import {Layer, layer} from './math/layer';
import ossUpload from './math/oss_upload';
import LimitStore from './math/limit_store';
import Tree from './math/tree';
import ImgUpload from './math/img_upload';
import Delay from './math/delay';
import ArrayTool from './math/array_tool';
import ImgTool from './math/img_tool';

import {
  getType,
  arrToHtml,
  assign,
  buildGetPara,
  clearFormData,
  convertTime,
  getPara,
  isIos
} from './math/basic';

import SjfxMath from './math/basic';


import {
  loadCss,
  loadRes,
  loadJs,
  loadModule,
  loadJquery,
  loadEcharts,
} from './math/load';

import ModelBasic from './math/model_basic';
import Validate from './math/validate';
import SearchStore from './math/search_store';
import StringTool from './math/string_tool';
import Check from './math/check';
import PageStore from './math/page_store';


import Md5 from './res/md5';

import dateInstall from './math/prototype/date';
import arrayInstall from './math/prototype/array';
import stringInstall from './math/prototype/string';
import NumberTool from './math/number_tool';

const install = function (opt) {
  dateInstall();
  arrayInstall();
  stringInstall();
  opt = opt || {};
  Ajax.pageMode = opt.pageMode || 'limit';

  //设置标题
  Vue.prototype.$setTitle = function (title) {
    document.title = title;
  };

  const lastPathKey = 'lastPath';
  //记住当前路径
  Vue.prototype.$rememberPath = function () {
    Global.set(lastPathKey, this.$route.path);
  };

  //移除记住的路径
  Vue.prototype.$clearRememberPath = function () {
    Global.remove(lastPathKey);
  };
  //返回记住的路径
  Vue.prototype.$backRememberPath = function (defPath) {
    const url = Global.get(lastPathKey) || defPath || '';
    Global.remove(lastPathKey);
    this.router.push(url);
  };
};

export {
  buildGetPara,
  install,
  Check,
  Ajax,
  Cache,
  DateTool,
  NumberTool,
  ArrayTool,
  DataModel,
  Event,
  Global,
  Layer,
  layer,
  ModelBasic,
  SearchStore,
  StringTool,
  Validate,
  ossUpload,
  OptionTool,
  Options,
  PageStore,
  loadCss,
  loadRes,
  loadJs,
  loadModule,
  loadJquery,
  loadEcharts,
  LimitStore,
  ImgUpload,
  getPara,

  ImgTool,

  Delay,
  getType,
  arrToHtml,
  assign,
  clearFormData,
  convertTime,
  isIos,

  Md5,
  Tree,
  SjfxMath,
  AjaxPro
};
export default {
  buildGetPara,
  install,
  Check,
  Ajax,
  AjaxPro,
  Cache,
  DateTool,
  NumberTool,
  ArrayTool,
  DataModel,
  Event,
  Global,
  Layer,
  layer,
  ModelBasic,
  SearchStore,
  StringTool,
  Validate,
  ossUpload,
  OptionTool,
  Options,
  PageStore,
  loadCss,
  loadRes,
  loadJs,
  loadModule,
  loadJquery,
  loadEcharts,
  LimitStore,
  isIos,
  getType,
  arrToHtml,
  assign,
  clearFormData,
  convertTime,
  Delay,
  ImgTool,

  Md5,
  Tree,
  SjfxMath,
}
