export default {
  /**
   * 获取数组中最小的元素
   * @param arr
   * @returns {*}
   */
  min(arr) {
    let result = arr[0];
    arr.forEach(item => {
      if (item < result)
        result = item;
    });
    return result;
  },
  /**
   * 获取数组中最大的元素
   * @param arr
   * @returns {*}
   */
  max(arr) {
    let result = arr[0];
    arr.forEach(item => {
      if (item > result)
        result = item;
    });
    return result;
  },

  /**
   * 读取指定页码的数据
   * @param {array} arr
   * @param {number} page
   * @param {number} limit
   */
  selectPageData(arr, page = 1, limit = 20) {
    if (arr.length === 0) {
      return [];
    }
    if (limit <= 0) {
      return arr;
    }
    if (page < 1) {
      page = 1;
    }
    const result = [];
    let start = (page - 1) * limit,
      end = start + limit - 1,
      max = arr.length - 1, i;
    if (start > max) {
      return [];
    }
    if (end > max) {
      end = max;
    }
    for (i = start; i <= end; i++) {
      result.push(arr[i]);
    }
    return result;
  },

  /**
   * 计算总页码
   * @param {number} totalRecord
   * @param {number}  pageSize
   * @returns {number}
   */
  getPageTotal(totalRecord, pageSize = 20) {
    return parseInt((totalRecord + pageSize - 1) / pageSize);
  }

}
