import {getType} from "../basic";
import {parse} from "./parse";
import tsToDate from "./ts_to_date";

function add_one_day(value, keys) {
  const type = getType(value);
  switch (type) {
    case 'Date':
      return new Date(value.valueOf()).addDays(1).format();//解除引用，避免影响原对象
    case 'String':
      return parse(value).addDays(1).format();
    case 'Number':
      return tsToDate(value).addDays(1).format();
    case 'Object':
      return convert(value, keys);
    default:
      return '';
  }
}

function convert(obj, keys) {
  const keyType = getType(keys);
  let result = Object.assign({}, obj);
  switch (keyType) {
    case 'String':
      keys = keys.split(',');
      break;
    case 'Array':
      break;
    default:
      return obj;
  }

  keys.forEach(function (name) {
    result[name] = add_one_day(result[name]);
  });
  return result;
}

export default add_one_day;
