import {getType} from '../basic'

function strToDate(str) {

  str = str.split('.')[0].replace(/\//g, '-');

  const dateStr = str.replace('T', ' ').split(' ');
  const arrDate = dateStr[0].split('-');
  if (arrDate.length !== 3) {
    console.log('strToDt：日期转换失败（' + str + '）');
    return new Date();
  }
  let arrTime = [0, 0, 0];
  if (dateStr.length > 1) {
    arrTime = dateStr[1].split(':');
    if (!arrTime[1]) {
      arrTime[1] = '0';
    }
    if (!arrTime[2]) {
      arrTime[2] = '0';
    }
  }
  return new Date(
    parseInt(arrDate[0]),
    parseInt(arrDate[1]) - 1,
    parseInt(arrDate[2]),
    parseInt(arrTime[0]),
    parseInt(arrTime[1]),
    parseInt(arrTime[2])
  );
}

/*
字符串转时间
 */
const parse = function (str): Date {
  const type = getType(str);
  switch (type) {
    case 'Date':
      return str;
    case 'String':
      return strToDate(str);
    case 'Number':
      return str > 1000000000000 ? new Date(str) : new Date(str * 1000);
    default:
      return new Date();
  }
};

export {parse} ;
