import {parse} from './parse'

export default function (time) {
  if (typeof time === 'string') {
    time = parse(time);
  }
  const now = new Date().valueOf() / 1000;
  const value = time.valueOf() / 1000;
  const distance = parseInt(now - value);
  if (distance > (365 * 24 * 3600)) {
    return parseInt(distance / (365 * 24 * 3600)) + '年前';
  } else if (distance > (30 * 24 * 3600)) {
    return parseInt(distance / (30 * 24 * 3600)) + '个月前';
  } else if (distance > (24 * 3600)) {
    return parseInt(distance / (24 * 3600)) + '天前';
  } else if (distance > 3600) {
    return parseInt(distance / 3600) + '小时前';
  } else if (distance > 60) {
    return parseInt(distance / 60) + '分钟前';
  } else {
    return '刚刚';
  }
}
