import {getType} from "../basic";
import {parse} from "./parse";

export default function (value) {
  const type = getType(value);
  switch (type) {
    case 'Date':
      return value;
    case 'String':
      return parse(value);
    case 'Number':
      return value > 1000000000000 ? new Date(value) : new Date(value * 1000);
    default:
      return new Date(1970, 0, 1);
  }
}
