class Delay {
  constructor(callback, need = 500) {
    this.need = need;

    this.djs = undefined;
    this.callback = callback;
  }

  trigger() {
    this.wait = this.need;
    if (this.djs) {
      return;
    }
    this.djs = setInterval(() => {
      this.wait = this.wait - 100;
      if (this.wait <= 0) {
        clearInterval(this.djs);
        this.djs = undefined;
        this.callback()
      }
    }, 100)
  }

  destroy() {
    if (this.djs) {
      clearInterval(this.djs);
      this.djs = null;
      this.callback = null;
    }

  }
}

export default Delay;
