import Ajax from './ajax'

let $g = window.$Global = window.$Global || {
  winHeight: window.innerHeight,
  winWidth: window.innerWidth,
  jquerySrc:'//cdn.bootcss.com/jquery/3.3.1/jquery.min.js'
};
let id = 10000;
const Global = {
  /**
   * 获取全局变量
   * @param name
   */
  get(name: string): any {
    return $g[name];
  },
  /**
   * 设置全局变量
   * @param name
   * @param value
   */
  set(name: string, value: any): void {
    $g[name] = value;
  },
  /**
   * 移除全局变量
   * @param name
   */
  remove(name: string): void {
    delete $g[name];
  },

  /**
   * 清除所有全局变量
   */
  removeAll(): void {
    $g = window.$Global = {
      winHeight: window.innerHeight
    };
  },
  newId() {
    id++;
    return id;
  },
  /**
   * 数据缓存
   * @param name - 缓存的变量名
   * @param api - 接口地址
   * @param paras - 参数
   * @param filter - 处理函数，可不传
   * @returns {*}
   */
  cache(name, api, paras = {}, filter) {
    if (Global.get(name)) {
      return new Promise(function (resolve) {
        resolve(Global.get(name));
      })
    } else {
      return Ajax.get(api, paras).then(data => {
        const result = filter ? filter(data) : data;
        Global.set(name, result);
        return result;
      });
    }
  }
};

export {
  Global
}

export default Global;
