/*
该类是一个虚类，默认应用于Ajax的错误提示和动画加载
使用本库，需要在Vue入口文件main.js或者app处重新定义类下各方法的实际实现
 */
class Layer {

  constructor() {
    this.ready = false;
  }

  /**
   * 弹出提示信息框
   * @param msg
   * @param title
   */
  alert(msg: string, title = '提示', type = '') {
    return new Promise(function (resolve, reject) {
      window.alert(msg);
      resolve();
    });
  }

  /**
   * 显示加载动画
   */
  loading() {
  }

  /**
   * 关闭加载动画
   */
  hideLoading() {
  }

  confirm(msg: string, title = '操作确认') {
    return new Promise(function (resolve, reject) {
      if (window.confirm(msg)) {
        resolve();
      } else {
        reject();
      }
    });
  }

  toptip(msg: string, type = 'error', closeTime) {
    window.alert(msg);
  }

  success(msg: string) {
    window.alert(msg);
  }

  error(msg: string) {
    window.alert(msg);
  }
}

const layer = new Layer();
export {Layer, layer};

export default layer
