export default class Limit_store {

  constructor(limit = 10, data = []) {
    if (IS_DEV) {
      if (limit < 1) {
        throw new Error('limit必须大于0');
      }
    }
    this.data = data;
    this.limit = limit;
    this.pageData = [];
    this.total = 0;
    this.totalPage = 0;
    this.nowPage = 1;
    this.load(data);
  }

  /**
   * 加载数据
   * @param data
   */
  load(data) {
    if (data) {
      this.data = data;
    }
    this.total = data.length;
    if (data.length === 0) {
      this.pageData = [];
      this.totalPage = 0;
    } else {
      this.totalPage = Math.ceil(this.total / this.limit);
      this.select(1);
    }
  }

  /**
   * 选择指定页码的数据
   * @param page
   * @returns {*}
   */
  select(page: number) {
    this.nowPage = page;
    //页码溢出
    if (page <= 0 || page > this.totalPage) {
      this.pageData = [];
      return;
    }
    let start = (page - 1) * this.limit;
    let end = start + this.limit - 1;
    if (end + 1 > this.total) {
      end = this.total - 1;
    }
    const result = [];
    for (let i = start; i <= end; i++) {
      result.push(this.data[i]);
    }
    this.pageData = result;
    return result;

  }

  /**
   * 设置分页大小
   * @param limit
   */
  setLimit(limit: number) {
    if (this.limit === limit) {
      return;
    }
    if (this.limit < 1) {
      throw new Error('limit不能小于1');
    }
    this.limit = limit;
    this.totalPage = Math.ceil(this.total / this.limit);
    this.select(1);
  }

}
