export default function () {

    /**
     * 首字母小写
     * @returns {string}
     */
    String.prototype.firstLowerCase = function () {
        return this.replace(/\b(\w)(\w*)/g, function ($0, $1, $2) {
            return $1.toLowerCase() + $2;
        });
    };
    /**
     * 首字母大写
     * @returns {string}
     */
    String.prototype.firstUpperCase = function () {
        return this.replace(/\b(\w)(\w*)/g, function ($0, $1, $2) {
            return $1.toUpperCase() + $2;
        });
    };

    /**
     *
     * @returns {string}
     */
    String.prototype.replaceSign = function (key, value) {
        return this.replace(new RegExp("({{" + key + "}})", "gi"), value);
    };
    /**
     * 替换字符串中所有匹配的字符
     * @param {string} reallyDo - 将要被替换的字符串
     * @param {string} replaceWith - 取代关键字的新字符串
     * @param {string} ignoreCase - 替换模式。默认为gi，全局匹配且不区分大小写
     * @returns {string}
     */
    String.prototype.replaceAll = function (reallyDo, replaceWith, ignoreCase) {
        if (!RegExp.prototype.isPrototypeOf(reallyDo)) {
            return this.replace(new RegExp(reallyDo, (ignoreCase ? "g" : "gi")), replaceWith);
        } else {
            return this.replace(reallyDo, replaceWith);
        }
    };
}
