/* @flow weak */

export default {

  /**
   * 还原被转义的Html特殊字符
   * @param str
   * @returns {*}
   */
  restoreHtml(str: string): string {
    if (str.length > 0) {
      str = str.replace(/&lt;/g, "<");
      str = str.replace(/&gt;/g, ">");
      str = str.replace(/&quot;/g, '"');
    }
    return str;
  },

  /**
   * 转义特殊字符
   * @param str
   * @returns {*}
   */
  kickHtml(str: string): string {
    if (str.length > 0) {
      str = str.replace(/</g, "&lt;");
      str = str.replace(/>/g, "&gt;");
      str = str.replace(/"/g, '&quot;');
    }
    return str;
  },
  /**
   * 显示换行
   * @param str
   * @returns {string}
   */
  showText(str: string) {
    let string = this.kickHtml(str);
    string = string.replace(/\r\n/g, "<br>");
    string = string.replace(/\n/g, "<br>");
    string = string.replace(/\s/g, "&nbsp;");
    return string;
  },
  /**
   * 限定字符串长度
   */
  maxLen(str, max) {
    if (!str) {
      return '';
    }
    if (str.length < max) {
      return str;
    }

    return str.substr(0, max) + '...';
  },
  /**
   * 获取字符串长度 1个汉字计2个字节
   */
  getLen(value: string) {
    if (!value) {
      return 0;
    }
    return value.replace(/[^\x00-\xff]/g, "ab").length;
  }
}
