class Local_data {

  constructor(limit = 20) {
    this.limit = limit;         // 每页加载数据条数
    this.dataList = [];         // 数据
    this.isEnd = false;         // 是否没有更多数据了
    this.loading = false;       // 是否正在加载
    this.text = {
      loading: '正在加载...',
      end: '没有更多数据了',
      empty: '暂无数据',
    };
    this.status = '';
    this.total = 0;
    this.totalPage = 0;
    this.isEmpty = false;
  }

  /**
   * 数据初始化
   * @param data
   */
  init(data) {
    this.data = data;
    this.total = this.data.length;
    this.pageNum = 1;           // 待加载的下一页数据
    this.totalPage = parseInt((this.total + this.limit - 1) / this.limit);         // 总页数
    this.isEmpty = this.total === 0;       // 是否没有任何数据
    this.dataList = [];
    if (this.isEmpty) {
      this.status = this.text.empty;
      return;
    }
    this.load();
  }

  /**
   * 加载下一页数据
   */
  load() {
    if (this.isEnd) {
      return;
    }
    const start = (this.pageNum - 1) * this.limit;//0
    let end = start + this.limit - 1;//9
    if (end >= this.total - 1) {
      end = this.total - 1;
      this.isEnd = true;
      this.status = this.text.end;
    }
    for (let i = start; i <= end; i++) {
      this.dataList.push(this.data[i]);
    }
    this.pageNum++;
  }
}


export default Local_data;
