class KeepSelect {

  constructor(target, key) {
    this.allSelect = new Set();    //所有已选
    this.lastSelectedList = [];   //上一次选中
    this.lock = false;
    this.total = 0;
    this.target = target;
    this.key = key || 'id';
  }

  onLoad(data) {
    data.forEach((item) => {
      if (this.isSelected(item)) {
        this.target.toggleRowSelection(item, true);
      }
    });
    this.lock = false;
  }

  onChange(pageDataList, nowSelectedList) {
    if (this.lock) {
      return;
    }
    const newSelectd = nowSelectedList.selectProp(this.key);
    //如果原来未选，则添加新值
    newSelectd.forEach((id) => {
      if (this.lastSelectedList.indexOf(id) === -1) {
        this.allSelect.add(id);
      }
    });
    //删除被取消选择的数据
    const allIds = pageDataList.selectProp(this.key);
    allIds.forEach((id) => {
      if (newSelectd.indexOf(id) === -1) {
        this.allSelect.delete(id);
      }
    });
    this.total = Array.from(this.allSelect).length;
  }


  /**
   * 判断是否选中
   * @param item
   * @param key
   * @returns {boolean}
   */
  isSelected(item) {
    return this.allSelect.has(item[this.key])
  }

  /**
   * 清除所有选中
   */
  clear() {
    this.allSelect.clear();
    this.lastSelectedList = [];
    this.total = 0;
    this.target.clearSelection();
  }

  getSelected() {
    return Array.from(this.allSelect);
  }
}

export default KeepSelect;
