import {Layer, layer} from '../math/layer';

export default function (that) {
  Layer.prototype.alert = function (msg, title = '出错啦') {
    return new Promise(function (resolve, reject) {
      that.$alert(msg, title, {
        callback: function () {
          resolve();
        }
      });
    });
  };
  Layer.prototype.loading = function () {
    that.loadingInstance = that.$loading({
      fullscreen: true
    });
  };
  Layer.prototype.hideLoading = function () {
    that.loadingInstance && that.loadingInstance.close();
  };

  Layer.prototype.error = Layer.prototype.toptip = (msg, type = 'error', closeTime = 3000) => {
    that.$message({
      message: msg,
      type: type,
      duration: closeTime
    });
  };


  Layer.prototype.confirm = (msg, title = '操作确认') => {
    return that.$confirm(msg, title, {
      type: 'warning'
    });
  };

  Layer.prototype.toast = (msg = '操作成功', type = '') => {
    return new Promise((resolve, reject) => {
      that.$notify({
        message: msg,
        type: type
      });
      resolve();
    });
  };

  Layer.prototype.success = function (msg) {
    this.toptip(msg, 'success')
  };
  Layer.prototype.warning = function (msg) {
    this.toptip(msg, 'warning')
  };
  layer.ready = true;
}

